require "itjobstack/version"
require "itjobstack/api.rb"

# @author Frank Pimenta
module Itjobstack
  # sets the credentials pair to jobstack in configuration object
  #
  # @deprecated Use {#set_config} instead
  # @return [Hash] both params pair 
  def config= email: , apiKey: 
    @@config = {email: email, apiKey: apiKey}
  end
  module_function :config=
  # sets the credentials pair to jobstack in configuration object
  #
  # @return [Hash] both params pair 
  def set_config email: , apiKey: 
    @@config = {email: email, apiKey: apiKey}
  end
  module_function :set_config
  # holds the credentials pair to jobstack
  #
  # @return [Hash] both params pair 
  def config
    @@config ||= {email: nil, apiKey: nil}
  end
  module_function :config
  # sets email in configuration object
  #
  # @return [String] credentials' email
  def email= email
    @@config.merge!({email: email})
  end
  module_function :email=
  # @return [String] credentials' email
  def email
    @@config && @@config.fetch(:email)
  end
  module_function :email
  # sets apiKey in configuration object
  #
  # @return [String] credentials' apiKey 
  def apiKey= apiKey 
    @@config.merge!({apiKey: apiKey})
  end
  module_function :apiKey=
  # @return [String] credentials' apiKey
  def apiKey 
    @@config && @@config.fetch(:apiKey)
  end
  module_function :apiKey
  #  @return [Boolean] credentials' presence 
  def has_config? 
    self.email && self.apiKey
  end
  module_function :has_config?
end
